import java.io.*;
import java.sql.*;
import java.util.*;

import org.apache.commons.pool.impl.*;
import org.apache.commons.dbcp.*;

//*************************************************************************************
// dbcp ϱ ؼ   ̺귯 ʿϴ
// DBCP API  Jar 
// DBCP API ϴ īŸ Pool API Jar 
// Pool API ϴ īŸ Collection API Jar 
// commons-dbcp-1.2.1 (Commons 	DBCP api)
// commons-collections-3.1 (Commons Collection api)
// commons-pool-1.2 (Commons Pool api)
//------------------------------------------------------------------------------------
// pool ϰ ִ ȿ sql   ߰ų ؼ Ŀؼ  Ǹ
// socket write error ߻Ѵ.   resin, tomcat ̳ʸ ٽ  ָ ȴ
// SQL    Error establishing socket ߻Ѵ.
// SQL  restartؾ Ѵ
// db.properties  ǰų ߰Ǿ 
// dbcp ؼ Connection ü Դٸ, con.close() ָ ˴ϴ.
//  dbؼ close Ǵ° ƴ϶ DBCP Poolٰ ݳϴ ۾ ̷ϴ.
//*************************************************************************************

public class DBCP
{
	private static DBCP instance = null;

	public static Connection getConnection (String path, String propertyName, boolean multiDriver, boolean autocommit) throws Exception
	{
		Connection con = null;

		if (instance == null)
		    {
		    synchronized (DBCP.class)
		    	{
				if (instance == null)
				    {
				    instance = new DBCP(path, multiDriver, autocommit);
				    }
				}
		    }
		// DBCP  ش Ǯ Ŀؼ  URL 'jdbc:apache:commons:dbcp:+Ǯ̸'̾ Ѵ
		// pool Ƽ  Configuration file not found ޽ ߻Ѵ
		// ޽ ä ؼ try catch Ѵ.
		try
		    {
			con = DriverManager.getConnection("jdbc:apache:commons:dbcp:" + propertyName);
		    }
		catch (Exception ex)
		    {
			throw new Exceptionx("[{0}]"+ex.getMessage(), Codes.toObjectArray(propertyName));
		    }
		return con;
	}

	private DBCP (String path, boolean multiDriver, boolean autocommit) throws Exception
	{
		init(path, multiDriver, autocommit);
	}

	private void init (String path, boolean multiDriver, boolean autocommit) throws Exception
	{
	    FileInputStream is;
	    Properties dbProps = new Properties();

	    try
			{
		    is = new FileInputStream(path);
		    dbProps.load(is);
			}
		catch (Exception e)
			{
			throw new Exceptionx("[{0}]   ϴ.", Codes.toObjectArray(path));
			}
		if (multiDriver == true) loadJDBCDrivers(path);
		else                     loadJDBCDrivers(dbProps);
		createPools(dbProps, autocommit);
	}

	//********************************************************************************
	// drivers ѹ εǸ ̳ʸ restŰ ʴ ޸𸮿  ִ´
	// db.properties ̹ ϸ  ̹ ö󰣴
	// ޸𸮿 2̻ ̹ εǾ   ִ
	// ׷ ѹ 2 ̻ ̹ Ѳ ε Ѵ
	// props.propetyNames, props.getProperty Ƽ ̸ ߺ  ʴ´
	//  ߿  drivers εϰ ȴ
	//  Ѳ εϰ ʹٸ mydb.drivers= ϰ α׷ ° ϸ ȴ
	// Exceptionx ϱ  throws ؾ Ѵ
	//********************************************************************************
	private void loadJDBCDrivers (Properties props) throws Exception
	{
		String driverClasses = props.getProperty("drivers", "sun.jdbc.odbc.JdbcOdbcDriver");

		StringTokenizer st = new StringTokenizer(driverClasses);
		while (st.hasMoreElements())
			{
			try
				{
				String driverClassName = st.nextToken().trim();
				//*********************************************************************
				// Class.forName() JDBC   JVM  ġ ϰ ȴ.
				//  ̰ ϱ ؼ Class.forNmae().newInstance() Ѵ
				//*********************************************************************
				Driver driver = (Driver)Class.forName(driverClassName).newInstance();
				DriverManager.registerDriver(driver);
				}
			catch (ClassNotFoundException ex)
				{
				throw new Exceptionx("[{0}]̹ ã  ϴ.", Codes.toObjectArray(ex.getMessage()));
				}
			catch (InstantiationException ex)
				{
				throw new Exceptionx("[{0}]̹ ʱȭ   ϴ.", Codes.toObjectArray(ex.getMessage()));
				}
			catch (SQLException ex)
				{
				throw new Exceptionx("[{0}]̹  ߻߽ϴ.", Codes.toObjectArray(ex.getMessage()));
				}
			catch (Exception ex)
				{
				throw new Exceptionx(ex.getMessage());
				}
			}
	}

	private void loadJDBCDrivers (String path) throws Exception
	{
//		String str = (new FileMgr(path, IOType.READ)).readLine("drivers", CodeType.EQUALS);
		String str = (new FileMgr(path, IOType.READ)).readLine();
		String line;
		StringTokenizer st = new StringTokenizer(str, CodeType.CRLF);
		StringTokenizer st2;

		while (st.hasMoreElements())
			{
			line = (String)st.nextElement();

			st2 = new StringTokenizer(line, "=");
			if (st2.hasMoreElements())
				{
				String name = (String)st2.nextElement();
				String driverClassName = st2.hasMoreElements() ? st2.nextToken().trim() : null;
				// readLine(key, delim) ϸ if   ʴ´
				if (driverClassName != null && Codes.checkEquals(name, "drivers") == true)
					{
					try
						{
						//*********************************************************************
						// Class.forName() JDBC   JVM  ġ ϰ ȴ.
						//  ̰ ϱ ؼ Class.forNmae().newInstance() Ѵ
						//*********************************************************************
						Driver driver = (Driver)Class.forName(driverClassName).newInstance();
						DriverManager.registerDriver(driver);
						}
					catch (ClassNotFoundException ex)
						{
						throw new Exceptionx("[{0}]̹ ã  ϴ.", Codes.toObjectArray(ex.getMessage()));
						}
					catch (InstantiationException ex)
						{
						throw new Exceptionx("[{0}]̹ ʱȭ   ϴ.", Codes.toObjectArray(ex.getMessage()));
						}
					catch (SQLException ex)
						{
						throw new Exceptionx("[{0}]̹  ߻߽ϴ.", Codes.toObjectArray(ex.getMessage()));
						}
					catch (Exception ex)
						{
						throw new Exceptionx(ex.getMessage());
						}
					}
				}
			}
	}

	private void createPools (Properties props, boolean autocommit) throws Exception
	{
		String[] keys = { ".url", ".user", ".password" };
		String[] propValues;
		String token;

		// null propertyName
		// ȭ ʿϸ Vector óѴ
		// List ֱ  ޴ʿ ݵ cast ؾѴ
		// Vector, ArrayList, LinkedList getPropertyList Ѵ
		Vector ve = (Vector)(new Collectionx(props, keys, CodeType.VECTOR)).getListProperties(null);
		for (int i = 0; i < ve.size(); i++)
			{
			// propValues[0] properyName̴
			// propValues[1] = keys[0] value
			// propValues[2] = keys[1] value
			// propValues[3] = keys[2] value
//			propValues = (String[])ve.get(i);
			// Collections.sort(obj) ϱ ؼ CodeType.CHAR_PART  String Ѱܹ޴´
			token = (String)ve.get(i);
			propValues = (new Stringx(token)).split(Codes.charPart());
			// ҹ ó Ѵ
			// propValues[0] properyName̴
			/**
			Ӽ 
			maxActive Ŀؼ Ǯ  ִ Ŀؼ 
			whenExhaustedAction Ŀؼ Ǯ   ִ Ŀؼ     Ѵ. 1  maxWait Ӽ  ðŭ Ŀؼ    ٸ, 0   ߻Ų. 2 쿡 Ͻ Ŀؼ ؼ Ѵ.
			maxWait whenExhaustedAction Ӽ  1  Ǵ  ð.  1/1000̸, 0     Ѵ.
			maxIdle  ʰ Ǯ   ִ ִ Ŀؼ .    .
			minIdle  ʰ Ǯ   ִ ּ Ŀؼ .
			testOnBorrow true  Ŀؼ Ǯ Ŀؼ   Ŀؼ ȿ θ ˻Ѵ.
			testOnReturn true  Ŀؼ Ǯ Ŀؼ ȯ  Ŀؼ ȿ θ ˻Ѵ.
			timeBetweenEvctionRunsMillis   Ŀؼ ϴ   ֱ⸦ Ѵ.  ƴ   ʴ´.  1/1000 ̴.
			numTestsPerEvictionRun  ʴ Ŀؼ   ˻ Ѵ.
			minEvictableIdleTimeMillis  ʴ Ŀؼ    Ӽ  ð ̻ Ȱȭ  ĿؼǸ Ѵ.  ƴ  Ȱȭ ðδ Ǯ ŵ ʴ´. ð  1/1000̴.
			testWhileIdle true  Ȱȭ Ŀؼ   Ŀؼ ȿ θ ˻ؼ ȿ  Ŀؼ Ǯ Ѵ.
			**/
			setup(propValues[0].trim(), propValues[1].trim(), propValues[2].trim(), propValues[3].trim(), autocommit);
			}
	}

	private void setup (String name, String url, String user, String password, boolean autocommit) throws Exception
	{
		// connection pool 
	    GenericObjectPool conPool = new GenericObjectPool(null);
		//  Ӽ ɿ ߿  ġ   ø̼ 뷮  ˸° ־ ϴµ,   ؼ  Ӽ  ϴ  .
		// maxActive - Ʈ ִ Ŀؼ 뷮  .  ڼ  Ѵ.
		conPool.setMaxActive(50);
		// minIdle -  ʴ Ŀؼ ּ  0 ϰ Ǹ Ǯ  Ŀؼ  0   ,   Ŀؼ ʿ  ٽ Ŀؼ ϰ ȴ.  Ŀؼ ּ  5  صδ  .
		conPool.setMaxIdle(10);
		// testWhileIdle -  ʴ Ŀؼ ˻  ȿ  Ŀؼ ˻ϴ  .
		conPool.setTestWhileIdle(true);
// Can't start manual transaction mode because ther are cloned connections
// Ʈ   Ŀؼ   
// statement ѹ ȣϰ ʰ ٽ ȣҶ  ߻Ѵ
// PoolableConnectionFactory autocommit true̸ setting  ʴ´
		// timeBetweenEvctionRunsMillis -   ˸° ؼ  ʴ Ŀؼ Ǯ ϴ  . Ŀؼ  뷮   ̸  ð뿡 ִ뿡 ̸ Ǵµ   ð뿡 ʿ Ŀؼ  ̴ ʰ ̸ ȴ. ̶ ִ ¿  ּ ·  Ǹ Ǯ  ʴ Ŀؼ   ϰ ȴ.   ʴ Ŀؼ  ð Ŀ ǵ ϴ  .  10~20   ʴ Ŀؼ ˻ϵ ϴ  .
		conPool.setTimeBetweenEvictionRunsMillis(600000);  // 1/1000, 600000 10 ȴ
		//  db Ŀؼ  ִ 丮 
		ConnectionFactory conFactory = new DriverManagerConnectionFactory(url, user, password);

		try
		    {
			// connection pool PoolableConnection ü Ҷ  poolableConnectionFactory 
			PoolableConnectionFactory poolableConFactory =
				new PoolableConnectionFactory(conFactory,
											  conPool,
											  null,   // statement pool
											  null,   // Ŀؼ Ʈ : Ŀؼ ȿ ׽ƮҶ 
											  false,  // б  ResultSet  . readonly 
										      // ܺο Ʈ   ϸ false ƴϸ true  Ѵ
											  autocommit);  // Ŀؼ autocommit 
		    }
		catch (Exception ex)
		    {
			throw new Exceptionx(ex.getMessage());
		    }
		PoolingDriver driver = new PoolingDriver();
		driver.registerPool(name, conPool);
	}
}

/*************************************************************************************
// okjsp.pe.kr ִ  source ״ ڵ

package com.webditto.connection;

import java.io.*;
import java.sql.*;
import java.util.*;

import com.webditto.*; // Exceptionx ִ
import com.webditto.util.*;
import com.webditto.io.*;

import org.apache.commons.pool.impl.*;
import org.apache.commons.dbcp.*;

//*************************************************************************************
// commons-dbcp-1.2.1 (Commons 	DBCP api)
// commons-collections-3.1 (Commons Collection api)
// commons-pool-1.2 (Commons Pool api)
// dbcp ϱ ؼ commons collection pool api ʿϴ
// dbcp ؼ Connection ü Դٸ, con.close() ָ ˴ϴ.
//  dbؼ close Ǵ° ƴ϶ DBCP Poolٰ ݳϴ ۾ ̷ϴ.
//*************************************************************************************

public class DBCP
{
	private static DBCP instance = null;

	public static Connection getPoolConnection (String propertyName) throws Exception
	{
		if (instance == null)
		    {
		    if (! init()) return null;
		    }
		// DBCP  ش Ǯ Ŀؼ  URL 'jdbc:apache:commons:dbcp:شǮ̸' ȴ
		Connection con = DriverManager.getConnection("jdbc:apache:commons:dbcp:" + propertyName);
		return con;
	}

	public static synchronized boolean init ()
	{
		if (instance == null)
		    {
		    DBCP dbcpPool = new DBCP();

		    InputStream is = dbcpPool.getClass().getResourceAsStream("db.properties");
		    Properties dbProps = new Properties();
		    try
				{
				try
				    {
				    dbProps.load(is);
				    }
				catch (Exception e)
	    			{
		    		}
				dbcpPool.loadDrivers(dbProps);
				dbcpPool.createPools(dbProps);
				}
			catch (Exception e)
				{
				return false;
				}
		    instance = dbcpPool;
		    }
		return true;
	}

	private void loadDrivers (Properties props)
	{
		String driverClasses = props.getProperty("drivers");
		StringTokenizer st = new StringTokenizer(driverClasses);

		while (st.hasMoreElements())
		    {
		    String driverClassName = st.nextToken().trim();
		    try
				{
				Driver driver = (Driver)Class.forName(driverClassName).newInstance();
				DriverManager.registerDriver(driver);
				}
		    catch (Exception e)
				{
				}
		    }
	}

	private void createPools (Properties props) throws Exception
	{
		Enumeration propNames = props.propertyNames();

		while (propNames.hasMoreElements())
		    {
		    String name = (String)propNames.nextElement();

		    if (name.endsWith(".url"))
				{
				String poolName = null, url;

				try
				    {
					poolName = name.substring(0, name.lastIndexOf("."));
				    url = props.getProperty(poolName + ".url");
				    if (url == null) continue;
				    setup(poolName, url);
				    }
				catch (Exception e)
				    {
				    }
				}
		    }
	}

	private void setup (String propertyName, String url) throws Exception
	{
	    GenericObjectPool conPool = new GenericObjectPool(null);
		conPool.setMaxActive(30);
		conPool.setMaxIdle(10);
		ConnectionFactory conFact = new DriverManagerConnectionFactory(url, null);
		PoolableConnectionFactory poolableConFact;

		try
		    {
		    poolableConFact = new PoolableConnectionFactory(conFact, conPool, null, null, false, true);
		    }
		catch (Exception e)
		    {
		    }
		PoolingDriver driver = new PoolingDriver();
		driver.registerPool(propertyName, conPool);
	}

	*****
	private void loadDrivers (Properties props)
	{
		Enumeration propNames = props.propertyNames();
		BasicDataSource bds = null;
		String name, pool, driver, url, user, password;
		int active, idle, wait;
		boolean autocommit, readonly;

		while (propNames.hasMoreElements())
		    {
		    name = (String)propNames.nextElement();

		    if (name.endsWith(".driver"))
				{
				try
				    {
				    pool = name.substring(0, name.lastIndexOf("."));
					driver = props.getProperty(pool + ".driver");
				    url = props.getProperty(pool + ".url");
				    user = props.getProperty(pool + ".user");
				    password = props.getProperty(pool + ".password");
				    active = Integer.parseInt(props.getProperty(pool + ".maxActive"));
				    idle = Integer.parseInt(props.getProperty(pool + ".maxIdle"));
				    wait = Integer.parseInt(props.getProperty(pool + ".maxWait"));
				    autocommit = props.getProperty(pool + ".defaultAutoCommit").equals("true");
				    readonly = props.getProperty(pool + ".defaultReadOnly").equals("true");

				    if (url == null) continue;
				    bds = new BasicDataSource();
				    bds.setDriverClassName(driver);
				    bds.setUrl(url);
				    bds.setUsername(user);
				    bds.setPassword(password);
				    bds.setMaxActive(active);
				    bds.setMaxIdle(idle);
				    bds.setMaxWait(wait);
				    bds.setDefaultAutoCommit(autocommit);
				    bds.setDefaultReadOnly(readonly);
				    setup(pool, bds);
				    }
				catch (Exception e)
				    {
				    }
				}
		    }
	}

	private void setup (String propertyName, BasicDataSource bds) throws Exception
	{
	    GenericObjectPool conPool = new GenericObjectPool(null);
		ConnectionFactory conFact = new DataSourceConnectionFactory(bds);
		PoolableConnectionFactory poolableConFact;

		try
		    {
		    poolableConFact = new PoolableConnectionFactory(conFact, conPool, null, null, false, true);
		    }
		catch (Exception e)
		    {
		    }
		PoolingDriver driver = new PoolingDriver();
		driver.registerPool(propertyName, conPool);
	}
	*****
}
*************************************************************************************/



