import java.io.*;
import java.sql.*;
import java.util.*;

//*********************************************************************************
// Connection Pool  ʰ Ź db.properties о óѴ
//*********************************************************************************
public class DBConnection
{
	// driver ϳ ѹ εѴ
	// mssql, oracle, mysql  db.properties   
	// ϳ dbms ؾ Ѵ
	public static Connection getConnection (String path, String propertyName, boolean multiDriver) throws Exception
	{
		Properties Props = init(path);
		if (multiDriver == true) loadJDBCDrivers(path);
		else                     loadJDBCDrivers(Props);
		return createConnection(Props, propertyName);
	}

	// Property óϴ ޼ҵ
	private static Properties init (String path) throws Exception
	{
		FileInputStream is;
		Properties dbProps = new Properties();

		try
			{
			is = new FileInputStream(path);
			dbProps.load(is);
			}
		catch (IOException e)
			{
			throw new Exceptionx("[{0}]   ϴ.", Codes.toObjectArray(path));
			}
		return dbProps;
	}

	//************************************************************************************
	// drivers ѹ εǸ ̳ʸ restŰ ʴ ޸𸮿  ִ´
	// db.properties ̹ ϸ  ̹ ö󰣴
	// ޸𸮿 2̻ ̹ εǾ   ִ
	// ׷ ѹ 2 ̻ ̹ Ѳ ε Ѵ
	// props.propetyNames, props.getProperty Ƽ ̸ ߺ  ʴ´
	//  ߿  drivers εϰ ȴ
	//  Ѳ εϰ ʹٸ mydb.drivers= ϰ α׷ ° ϸ ȴ
	//************************************************************************************
	private static void loadJDBCDrivers (Properties props) throws Exception
	{
		String driverClasses = props.getProperty("drivers", "sun.jdbc.odbc.JdbcOdbcDriver");

		StringTokenizer st = new StringTokenizer(driverClasses);
		while (st.hasMoreElements())
			{
			try
				{
				String driverClassName = st.nextToken().trim();
				//*********************************************************************
				// Class.forName() JDBC   JVM  ġ ϰ ȴ.
				//  ̰ ϱ ؼ Class.forNmae().newInstance() Ѵ
				//*********************************************************************
				Class.forName(driverClassName).newInstance();
//				Class.forName(driverClassName);
				}
			catch (ClassNotFoundException ex)
				{
				throw new Exceptionx("[{0}]̹ ã  ϴ.", Codes.toObjectArray(ex.getMessage()));
				}
			catch (Exception ex)
				{
				throw new Exceptionx(ex.getMessage());
				}
			}
	}

	// driver      о εѴ
	private static void loadJDBCDrivers (String path) throws Exception
	{
//		String str = (new FileMgr(path, IOType.READ)).readLine("drivers", CodeType.EQUALS);
		String str = (new FileMgr(path, IOType.READ)).readLine();
		String line;
		StringTokenizer st = new StringTokenizer(str, CodeType.CRLF);
		StringTokenizer st2;

		while (st.hasMoreElements())
			{
			line = (String)st.nextElement();

			st2 = new StringTokenizer(line, "=");
			if (st2.hasMoreElements())
				{
				String name = (String)st2.nextElement();
				String driverClassName = st2.hasMoreElements() ? st2.nextToken().trim() : null;
				// readLine(key, delim) ϸ if   ʴ´
				if (driverClassName != null && Codes.checkEquals(name, "drivers") == true)
					{
					try
						{
						//*********************************************************************
						// Class.forName() JDBC   JVM  ġ ϰ ȴ.
						//  ̰ ϱ ؼ Class.forNmae().newInstance() Ѵ
						//*********************************************************************
						Class.forName(driverClassName).newInstance();
//						Class.forName(driverClassName);
						}
					catch (ClassNotFoundException ex)
						{
						throw new Exceptionx("[{0}]̹ ã  ϴ.", Codes.toObjectArray(ex.getMessage()));
						}
					catch (Exception ex)
						{
						throw new Exceptionx(ex.getMessage());
						}
					}
				}
			}
	}

	// propertyName 2 ̻ ߺǾ    settingȴ
	private static Connection createConnection (Properties props, String propertyName) throws Exception
	{
		String[] keys = { ".url", ".user", ".password" };
		String[] propValues;
		String token;

		// null propertyName
		// ȭ ʿϸ Vector óѴ
		// List ֱ  ޴ʿ ݵ cast ؾѴ
		// Vector, ArrayList, LinkedList getPropertyList Ѵ
		Vector ve = (Vector)(new Collectionx(props, keys, CodeType.VECTOR)).getListProperties(propertyName);

/*
		// propValues[0] properyName̴
		// propValues[1] = url
		// propValues[2] = user
		// propValues[3] = password
		propValues = (String[])ve.get(0);
		return DriverManager.getConnection(propValues[1].trim(), propValues[2].trim(), propValues[3].trim());
*/
		// Collections.sort(obj) ϱ ؼ CodeType.CHAR_PART  String Ѱܹ޴´
		token = (String)ve.get(0);
		propValues = (new Stringx(token)).split(Codes.charPart());
		return DriverManager.getConnection(propValues[1].trim(), propValues[2].trim(), propValues[3].trim());
	}
}

