import java.sql.*;
import java.util.*;

//*********************************************************************************
// Connection Pool ó Ѵ
//*********************************************************************************
public class DBConnectionPool
{
	private int checkedOut;
	private Vector freeConnections = new Vector();
	private int maxConn;
	// Execute ϱ  public Ѵ. get method  ʴ´
	private String name;
	private String password;
	private String URLs;
	private String user;

	// Ƽ ִ 50 connection ϵ Ѵ
	public static final int DEFAULT_MAX_CON = 50; // 20;

	public DBConnectionPool (String name, String URLs, String user, String password, int maxConn)
	{
		this.name = name;
		this.URLs = URLs;
		this.user = user;
		this.password = password;
		this.maxConn = maxConn;

		if ( this.maxConn <= 0 ) {
			this.maxConn = DEFAULT_MAX_CON;
		}
	}

/*
	public String getURL ()
	{
		return this.URLs;
	}

	public String getUser ()
	{
		return this.user;
	}

	public String getPassword ()
	{
		return this.password;
	}
*/

	public synchronized Connection getConnection () throws Exception
	{
		Connection conn = null;

		while( freeConnections.size() <= 0 )
			{
			if ( checkedOut < maxConn )
				{
				conn = newConnection();
				break;
				}
			try
				{
				// Ǿ ִ Connection  
				// Connection ȯ   ٸ.
				wait();
				}
			catch (InterruptedException ex) {}
			}

		if ( conn == null )
			{
			conn = (Connection) freeConnections.firstElement();
			freeConnections.removeElementAt(0);

			try
				{
				if ( conn.isClosed() )
					{
					conn = newConnection();
					}
				}
			catch (SQLException ex)
				{
				conn = newConnection();
				}
			}
		if (conn != null)
			{
			checkedOut++;
			}
		else
			{
			// db connecion   
			throw new Exceptionx("db connecion   ϴ.");
			}
		return conn;
	}

	private Connection newConnection ()
	{
		Connection conn = null;

		try
			{
			if (user == null)
				{
				conn = DriverManager.getConnection(URLs);
				}
			else
				{
				conn = DriverManager.getConnection(URLs, user, password);
				}
			}
		catch (SQLException ex)
			{
			return null;
			}
		return conn;
	}

	public synchronized void returnConnection (Connection conn)
	{
		// Connection Vector   Ѵ.
		freeConnections.addElement(conn);
		checkedOut--;
		notifyAll();
	}

	public synchronized void close ()
	{
		Enumeration allConnections = freeConnections.elements();
		while (allConnections.hasMoreElements())
			{
			Connection conn = (Connection) allConnections.nextElement();
			try
				{
				conn.close();
				}
			catch (SQLException ex) { }
			}
		freeConnections.removeAllElements();
	}
}
